# coding: utf-8

from django.utils.encoding import (
    smart_text)

from ConfigParser import (
    SafeConfigParser,
    NoSectionError,
    NoOptionError)


class ExtendedConfigParser(SafeConfigParser, object):
    def __init__(self, defaults=None, *args, **kwargs):
        super(ExtendedConfigParser, self).__init__(None, *args, **kwargs)

        self._extended_defaults = defaults

    def get(self, section, option):
        try:
            result = smart_text(super(ExtendedConfigParser, self).get(section, option))
        except Exception as e:
            if isinstance(e, (NoSectionError, NoOptionError)):
                try:
                    result = self._extended_defaults[(section, option)]
                except:
                    raise e
            else:
                raise e

        return result
