# coding: utf-8

from datetime import (
    datetime, date)

from datatransfer.common.xml.parser import (
    XMLModelParser)
from datatransfer.source.get_data.etl.packet.extractor.common.mapping import (
    rules as extractor_rules)


RULES = XMLModelParser.rules
MODEL = XMLModelParser.model
RECORD = XMLModelParser.record
DATA = XMLModelParser.data


def unbinded2none(value):
    if value in (-1, '-1'):
        return None

    return value


rules = RULES(
    '__rule__', MODEL(),
    'Packet', RULES(
        '__rule__', MODEL(),
        'Header', RULES(
            '__rule__', RECORD(a=False),
            'SourceSystemID', RULES(
                '__rule__', DATA(unicode)),
            'AuthorizationKey', RULES(
                '__rule__', DATA(unicode)),
            'DestinationSystemID', RULES(
                '__rule__', DATA(unicode)),
            'Timestamp', RULES(
                '__rule__', DATA(datetime)),
            'SessionID', RULES(
                '__rule__', DATA(unicode))),
        'Data', RULES(
            '__rule__', MODEL(),
            'Persons', RULES(
                '__rule__', MODEL(),
                'Person', RULES(
                    '__rule__', RECORD(),
                    'ID', RULES(
                        '__rule__', DATA(int, m=extractor_rules.extract_person_id)),
                    'RegionalID', RULES(
                        '__rule__', DATA(int)),
                    'FederalID', RULES(
                        '__rule__', DATA(unicode)),
                    'SourceID', RULES(
                        '__rule__', DATA(int)),
                    'ExternalID', RULES(
                        '__rule__', DATA(int)),
                    'FirstName', RULES(
                        '__rule__', DATA(unicode)),
                    'MiddleName', RULES(
                        '__rule__', DATA(unicode)),
                    'LastName', RULES(
                        '__rule__', DATA(unicode)),
                    'Gender', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'BirthDate', RULES(
                        '__rule__', DATA(date)),
                    'BirthPlace', RULES(
                        '__rule__', DATA(unicode)),
                    'SNILS', RULES(
                        '__rule__', DATA(unicode)),
                    'HealthGroup', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'LongTermTreatment', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'DisabilityGroup', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'DisabilityExpirationDate', RULES(
                        '__rule__', DATA(date)),
                    'DisabilityReason', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'AdaptationProgram', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'PhysicalCultureGroup', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'DifficultSituation', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'DocumentRegistryNumber', RULES(
                        '__rule__', DATA(unicode)),
                    'DocumentRegistryIssuer', RULES(
                        '__rule__', DATA(unicode)),
                    'DocumentRegistryIssueDate', RULES(
                        '__rule__', DATA(date)),
                    'Citizenship', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'RegistrationAddressPlace', RULES(
                        '__rule__', DATA(unicode)),
                    'RegistrationAddressStreet', RULES(
                        '__rule__', DATA(unicode)),
                    'RegistrationAddressHouse', RULES(
                        '__rule__', DATA(unicode)),
                    'RegistrationAddressFlat', RULES(
                        '__rule__', DATA(unicode)),
                    'RegistrationAddress', RULES(
                        '__rule__', DATA(unicode)),
                    'ResidenceAddressPlace', RULES(
                        '__rule__', DATA(unicode)),
                    'ResidenceAddressStreet', RULES(
                        '__rule__', DATA(unicode)),
                    'ResidenceAddressHouse', RULES(
                        '__rule__', DATA(unicode)),
                    'ResidenceAddressFlat', RULES(
                        '__rule__', DATA(unicode)),
                    'ResidenceAddress', RULES(
                        '__rule__', DATA(unicode)),
                    'ActualAddressPlace', RULES(
                        '__rule__', DATA(unicode)),
                    'ActualAddressStreet', RULES(
                        '__rule__', DATA(unicode)),
                    'ActualAddressHouse', RULES(
                        '__rule__', DATA(unicode)),
                    'ActualAddressFlat', RULES(
                        '__rule__', DATA(unicode)),
                    'ActualAddress', RULES(
                        '__rule__', DATA(unicode)))),
            'PersonDocuments', RULES(
                '__rule__', MODEL(),
                'Document', RULES(
                    '__rule__', RECORD(),
                    'ID', RULES(
                        '__rule__', DATA(int, m=extractor_rules.extract_document_id)),
                    'PersonRegionalID', RULES(
                        '__rule__', DATA(int)),
                    'PersonLocalID', RULES(
                        '__rule__', DATA(int)),
                    'Person', RULES(
                        '__rule__', DATA(int)),
                    'SourceID', RULES(
                        '__rule__', DATA(int)),
                    'ExternalID', RULES(
                        '__rule__', DATA(int)),
                    'Type', RULES(
                        '__rule__', DATA(unicode, m=unbinded2none)),
                    'Series', RULES(
                        '__rule__', DATA(unicode)),
                    'Number', RULES(
                        '__rule__', DATA(unicode)),
                    'Issuer', RULES(
                        '__rule__', DATA(unicode)),
                    'IssueDate', RULES(
                        '__rule__', DATA(date)))))))
