


/*  {% comment %}
 *
 *  Доработка грида с колонкой чекбоксов, исправляющая сброс
 *  чекбоксов при переходе на другую страницу в гриде.
 *
 *  {% endcomment %}
 */

    var _grid = Ext.getCmp('{{ component.grid.client_id}}');
    // массив id выбранных элементов
    _grid.SelectedValuesIds = [];
    var selectionModel = _grid.getSelectionModel();


    // {# При установке/снятии галочки в строке           #}
    // {# помещаем id записи в массив выбранных элементов #}
    selectionModel.on('rowselect', function (sm, rowIndex, record) {
        if (_grid.SelectedValuesIds.indexOf(record.id) == -1) {
            _grid.SelectedValuesIds.push(record.id);
        }
    });

    selectionModel.on('rowdeselect', function (sm, rowIndex, record) {
        if (_grid.SelectedValuesIds.indexOf(record.id) != -1) {
            _grid.SelectedValuesIds.splice(_grid.SelectedValuesIds.indexOf(record.id), 1);
        }
    });


    // {# При загрузке store отмечаем выбранные элементы, #}
    // {# которые доступны на данной странице             #}
    _grid.getStore().on('load', function (store, records, options) {
        var selectedRecords = records.filter(function(record) {
            return _grid.SelectedValuesIds.indexOf(record.id) != -1
        })

        selectionModel.suspendEvents();
        selectionModel.selectRecords(selectedRecords);
        selectionModel.resumeEvents();
    });


    /* {# Принять изменения из Контингента #} */
    function apply_changes() {

        if (_grid.getSelectionModel().hasSelection()) {
            Ext.Msg.confirm(
                'Внимание',
                'Вы действительно хотите принять изменения из Контингента по данному учащемуся/учащимся?',
            function (btn){
                if (btn === 'yes'){
                    Ext.Ajax.request({
                        url: '{{ component.apply_url}}',
                        method: 'POST',
                        params: {'persons': _grid.SelectedValuesIds.join(',')},
                        success: function (response, options) {
                            win.getEl().unmask();
                            var obj = Ext.util.JSON.decode(response.responseText);
                            if (obj.message) {
                                Ext.Msg.alert('Внимание', obj.message);
                            }
                        }, failure: function (response, options) {
                            win.getEl().unmask();
                            uiAjaxFailMessage(response, options);
                        }
                    })
                }
            }
            );
        } else {
            Ext.Msg.alert('Внимание', 'Элемент не выбран');
        }
    }


// {# нумерация строк в гриде #}
function numRenderer(value, metData, record, rowIndex, colIndex, store) {
    var start = 0;
    if (store.lastOptions && store.lastOptions.params) {
        start = store.lastOptions.params.start;
    }
    return start + rowIndex + 1;
}
