# coding: utf-8

from spyne.model import (
    ComplexModel,
    Unicode,
    Enum)

from datatransfer.common.constants import MODE_ALL, MODE_UPDATED
from datatransfer.common import (
    constants)


class ComplexModelWithNamespace(ComplexModel):
    __namespace__ = constants.DATAPUSH_NAMESPACE


class DataPushRequest(ComplexModelWithNamespace):
    AuthorizationKey = Unicode
    SessionID = Unicode
    Mode = Enum(MODE_ALL, MODE_UPDATED, type_name='Mode')


class DataPushResponse(ComplexModel):
    __namespace__ = constants.DATAPUSH_NAMESPACE + '/response'
    SessionID = Unicode
    Message = Unicode


class FeedbackRequest(ComplexModelWithNamespace):
    AuthorizationKey = Unicode
    SessionID = Unicode


class FeedbackResponse(DataPushResponse):
    pass
